%define major 5
%define soffix .so.5

Name: lua%major
Version: 5.0.2
Release: alt5

Summary: Lua is a powerful, light-weight programming language
License: MIT
Group: Development/Other

URL: http://www.lua.org
# http://www.lua.org/ftp/
Source0: lua-%version.tar.bz2
# http://www.keplerproject.org/compat/
Source1: compat-5.1r3.tar.gz

# known bugs in Lua: http://www.lua.org/bugs.html
Patch1: lua-5.0.2-lua-lvm-concat.patch
Patch2: lua-5.0.2-lua-lapi-upval.patch
Patch3: lua-5.0.2-lua-lgc-mark.patch

# ftp://ftp.debian.org/debian/pool/main/l/lua50/
Patch20: lua50_5.0.2-5.diff.gz
# http://news.gw.com/openbsd.ports/%3C20040113143852.GA7683@vogt.ambientworks.net%3E
Patch21: lua-5.0.1-pedro-openbsd-snprintf.patch
# https://bugzilla.altlinux.org/show_bug.cgi?id=6539
Patch22: lua-5.0.2-alt-lu_hash-intptr.patch

# alternatives
%define weight 20
%set_compress_method gzip
PreReq: alternatives >= 0.2
BuildPreReq: alternatives >= 0.2

Requires: lib%name = %version-%release
Provides: lua = %version

# Added by buildreq2 on Sat Jun 11 2005
BuildRequires: libreadline-devel

%package -n lib%name
Summary: Lua programming language, shared libraries
Group: System/Libraries

%package -n lib%name-devel
Summary: Lua programming language, header files
Group: Development/Other
Requires: lib%name = %version-%release
Conflicts: liblua4-devel

%package -n lib%name-devel-static
Summary: Lua programming language, static libraries
Group: Development/Other
Requires: lib%name-devel = %version-%release
Conflicts: liblua4-devel-static

%description
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains lua compiler and interpreter, as well as code samples
and reference manual of the language.

%description -n lib%name
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains lua runtime shared libraries.

%description -n lib%name-devel
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains header files needed to embed Lua in C/C++ programs.

%description -n lib%name-devel-static
Lua is a powerful, light-weight programming language designed for extending
applications.  Lua is also frequently used as a general-purpose, stand-alone
language.

This package contains static libraries one may need to embed lua statically.

%prep
%setup -q -n lua-%version -a1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1

%__perl -pi -e 's/\s*\z/\n/' compat-5.1*/*.*
%__cp -a compat-5.1*/compat-5.1.h include/
%__cp -a compat-5.1*/compat-5.1.c src/lib/
%__cp -a compat-5.1*/compat-5.1.lua etc/

%__perl -pi -e s:/usr/local/share/lua/5.0/:%_datadir/%name/:g, \
	-e s:/usr/local/lib/lua/5.0/:%_libdir/%name/:g etc/compat-5.1.lua
! diff -u compat-5.1*/compat-5.1.lua etc/compat-5.1.lua

%build
%def_enable Werror

: custom build
DEST=$PWD/ready
%__mkdir_p $DEST

# tweak stdio.h with -D_GNU_SOURCE to get popen(3) and pclose(3) prototypes
CFLAGS="-I$PWD/include -I$PWD/src -I$PWD/etc -D_GNU_SOURCE=1
	-DUSE_POPEN=1
	-DUSE_DLOPEN=1
	-DUSE_TMPNAME=1
	-DLUA_COMPATUPSYNTAX=1
	-DLUA_OPNAMES=1
	-DLUA_PATH_DEFAULT=\"?;?.lua;%_datadir/%name/?;%_datadir/%name/?.lua\"
%ifarch %ix86
	-DLUA_USER_H=\"luser_number.h\"
	-DUSE_FASTROUND=1
%endif
	-DLUA_USERCONFIG=\"$PWD/etc/saconfig.c\"
	-DUSE_READLINE=1
"

: static libraries
cd ./src
gcc $CFLAGS %optflags -c *.c
ar rcu $DEST/liblua.a *.o
ranlib $DEST/liblua.a

cd ./lib
gcc $CFLAGS %optflags -c *.c
ar rcu $DEST/liblualib.a *.o
ranlib $DEST/liblualib.a

: shared libraries
cd ..
gcc $CFLAGS %optflags %optflags_shared -c *.c
gcc -shared -o $DEST/liblua%soffix -Wl,-soname=liblua%soffix *.o
%__ln_s liblua%soffix $DEST/liblua.so

cd ./lib
gcc $CFLAGS %optflags %optflags_shared -c *.c
gcc -shared -o $DEST/liblualib%soffix -Wl,-soname=liblualib%soffix *.o -lm -ldl -L$DEST -llua
%__ln_s liblualib%soffix $DEST/liblualib.so

: executables
cd ../lua
gcc $CFLAGS %optflags *.c -o $DEST/lua -L$DEST -llua -llualib -lreadline
cd ../luac
gcc $CFLAGS %optflags *.c -o $DEST/luac -L$DEST -llua -llualib

: test
cd ../..
LD_LIBRARY_PATH=$DEST $DEST/lua test/hello.lua
LD_LIBRARY_PATH=$DEST $DEST/lua test/cf.lua

%install
%__mkdir_p %buildroot%_libdir %buildroot%_includedir
%__cp -a ready/*.so* ready/*.a %buildroot%_libdir
%__install -p -m644 include/*.h %buildroot%_includedir

%__install -pD -m755 ready/lua %buildroot%_bindir/lua%major
%__install -pD -m755 ready/luac %buildroot%_bindir/luac%major
%__install -pD -m644 doc/lua.1 %buildroot%_man1dir/lua%major.1
%__install -pD -m644 doc/luac.1 %buildroot%_man1dir/luac%major.1

%__mkdir_p %buildroot%_libdir/%name %buildroot%_datadir/%name
%__install -p -m644 etc/compat.lua etc/compat-5.1.lua %buildroot%_datadir/%name

%define pkgdocdir %_docdir/lua-%version
%__mkdir_p %buildroot%pkgdocdir/{html,etc,test}
%__install -p -m644 COPYRIGHT HISTORY README* %buildroot%pkgdocdir
%__install -p -m644 UPDATE %buildroot%pkgdocdir
%__install -p -m644 doc/*.html doc/*.gif %buildroot%pkgdocdir/html
%__install -p -m644 etc/*.* etc/README %buildroot%pkgdocdir/etc
%__install -p -m644 test/*.lua test/README %buildroot%pkgdocdir/test

%__mkdir_p %buildroot%_altdir
%__cat <<__EOF__ >%buildroot%_altdir/%name
%_bindir/lua		%_bindir/%name			%weight
%_bindir/luac		%_man1dir/luac%major		%_bindir/%name
%_man1dir/lua.1.gz	%_man1dir/%name.1.gz		%_bindir/%name
%_man1dir/luac.1.gz	%_man1dir/luac%major.1.gz	%_bindir/%name
__EOF__

%post
%register_alternatives %name

%preun
%unregister_alternatives %name

%post -n lib%name -p %post_ldconfig
%postun -n lib%name -p %postun_ldconfig

%files
%_altdir/*
%_bindir/lua*
%_man1dir/*.*
%dir %pkgdocdir
%pkgdocdir/html
%pkgdocdir/etc
%pkgdocdir/test

%files -n lib%name
%_libdir/liblua%soffix
%_libdir/liblualib%soffix
%dir %_libdir/%name
%dir %_datadir/%name
%_datadir/%name/compat.lua
%_datadir/%name/compat-5.1.lua
%dir %pkgdocdir
%pkgdocdir/COPYRIGHT
%pkgdocdir/HISTORY
%pkgdocdir/README*
%pkgdocdir/UPDATE

%files -n lib%name-devel
%_includedir/*.h
%_libdir/liblua.so
%_libdir/liblualib.so

%files -n lib%name-devel-static
%_libdir/liblua.a
%_libdir/liblualib.a

%changelog
* Wed Jun 29 2005 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt5
- fixed segfaults introduced in previous release (type casts)
- fixed linkage (linked liblualib.so with liblua.so)

* Sat Jun 11 2005 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt4
- compat-5.1r2 -> compat-5.1r3
- in sync with Debian: lua50_5.0.2-5.diff.gz
- fixed invalid type casts on x86_64 (Kachalov Anton, #6539)

* Mon May 09 2005 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt3
- packaged Compat-5.1 (implementation of Lua-5.1 package proposal)
- applied 3 official patches from http://www.lua.org/bugs.html
- removed old dependencies

* Sat Sep 18 2004 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt2
- %_datadir/%name/loadlib.lua -- implemented require()-like path search
  for loadlib(); compiled extensions should reside in %_libdir/%name
- added %_datadir/%name to default LUA_PATH
- enabled os.tmpname()
- upgraded to new alternatives format

* Fri Mar 19 2004 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt1
- updated to 5.0.2 release
- enabled partial compatibility with old upvalue syntax
- pedro-openbsd-snprintf.patch: use snprintf(3) instead of sprintf(3)

* Sun Mar 07 2004 Alexey Tourbin <at@altlinux.ru> 5.0.2-alt0.1
- updated to 5.0.2 pre-release, with all official patches in

* Mon Feb 23 2004 Alexey Tourbin <at@altlinux.ru> 5.0-alt7.2
- %_docdir/%name-%version -> %_docdir/lua-%version
- fixed luac symilnk (alternatives)

* Mon Feb 02 2004 Alexey Tourbin <at@altlinux.ru> 5.0-alt7.1
- fixed %_docdir/%name-%version ownership

* Fri Jan 30 2004 Alexey Tourbin <at@altlinux.ru> 5.0-alt7
- fixed _customdocdir misusage
- Werror mode enabled

* Tue Nov 18 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt6
- 5 more official patches applied

* Sun Aug 24 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt5
- moved lua4 (weight=10) and lua5 (weight=20) packages under alternatives control
- in sync with debian (deb-paths.patch):
  + Added support for -C to load compatibility library on startup
  + Added an initial LUA_PATH to support /usr/share/lua5 etc.
  + Added a -P switch to suppress the LUA_PATH code if need-be
  + Updated the manpage lua.1 for the -C and -P switches

* Fri Jun 20 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt4
- packages renamed: s/lua/lua5/
- lua4 will be kept; thus Provides/Obsoletes reconsidered, Conflicts added
- two patches from http://www.lua.org/bugs.html
- Sisyphus release

* Wed May 07 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt3
- added Provides and Obsoletes for smooth upgrade

* Mon May 05 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt2
- desert Makefile/config/patches; custom build with direct commands
- features enabled: dlopen (loadlib), popen, fastround, libreadline
- new package layout: lua, liblua, liblua-devel, liblua-devel-static

* Mon Apr 28 2003 Alexey Tourbin <at@altlinux.ru> 5.0-alt1
- 5.0; API changes; soname changed; license: MIT
- loadlib now implemented, so drop that stuff borrowed from PLD

* Sun Jan 19 2003 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt6
- minor enhancements

* Thu Dec 26 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt5
- corrected s/-lc/-lc -lm -ldl/ for liblualib.so in alt-soname patch
- shared optimization flags

* Tue Dec 24 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt4
- error in previous build: *.so files are binary copy of *.so.* files,
  not symlinks; fixed
- really shared build (s/ld -shared/ld -shared -lc/ in alt-soname patch)
- post and postun sections added (ldconfig)

* Fri Dec 20 2002 Alexey Tourbin <at@altlinux.ru> 4.0.1-alt3
- shared build; alt-soname patch; lua-devel-static subpackage
- reference manual and code samples included in lua-devel package
- additional features from XTG Systems (loadlib files) and
  PLD Team (pld-loadlib-require patch)
- buildreq applied (none)

* Mon Oct 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.1-alt2
- Rebuilt in new environment

* Wed Aug 28 2002 Konstantin Volckov <goldhead@altlinux.ru> 4.0.1-alt1
- First build for Sisyphus
